<?php

namespace Services\Logic;
class CopiaContratoLogic{
    
      public static function copiaContrato($nrorg, $nrseqcontrato, $tipo='C'){
            $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
             
            try{
                  $connection->beginTransaction();

                  $contrato = self::getContrato($nrorg, $nrseqcontrato);  
                  $nrNovoContrato = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'FCT_CONTRATO',1,10);
                  $contrato = $contrato[0];
                  $contrato['NRSEQCONTRATO'] = $nrNovoContrato;
                  $contrato['NRCONTRATOFCT'] = $nrNovoContrato;
                  if($tipo === 'V'){
                        $nrcontratopai = $contrato['NRSEQCONTRATOPAI'];
                        if(empty($nrcontratopai))
                              $nrcontratopai = $nrseqcontrato;

                        $contrato['NRVERSAOCONTRATO'] = self::getMaxVersaoContr($nrorg, $nrcontratopai);
                        $contrato['NRSEQCONTRATOPAI'] = $nrcontratopai;
                  }elseif($tipo === 'C'){
                        $contrato['NRSEQCONTRATOPAI'] = '';
                        $contrato['NRVERSAOCONTRATO'] = '1';
                  }
                  $contrato['IDSITUACAOCONTRATO'] = 'P';

                  $contrato['DTINCLUSAO'] = now();
                  $contrato['DTULTATU'] = now();
                  $contrato['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                  $contrato['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();
               
                  @self::insereContrato($contrato);
                  $mnemonico = OrcamentoLogic::executaProcedure($nrorg, $nrNovoContrato, 'C');
                 
                  $faturamentoContArray = self::getFaturamentoCont($nrorg, $nrseqcontrato);
                  foreach($faturamentoContArray as $faturamento){
                        $faturamento['NRSEQFATUCONTR'] = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'NRSEQFATUCONTR',1,10,true);
                        $faturamento['NRSEQCONTRATO'] = $nrNovoContrato;
                        $faturamento['DTINCLUSAO'] = now();
                        $faturamento['DTULTATU'] = now();
                        $faturamento['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                        $faturamento['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();

                        @self::insereFaturamentoCont($faturamento);

                  }

                  unset($faturamentoContArray);

                  //itens
                  $itensContArray = self::getItensContrato($nrorg,$nrseqcontrato);
                  

                  foreach($itensContArray as $itemContrato){
                        $nritemOld = $itemContrato['NRITEMOCONTRATO'];
                        $nritemcontrato = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'FCT_ITEMCONTRATO',1,10,true);
                        $itemContrato['NRSEQCONTRATO'] = $nrNovoContrato;
                        $itemContrato['NRITEMOCONTRATO'] = $nritemcontrato;

                        $itemContrato['DTINCLUSAO'] = now();
                        $itemContrato['DTULTATU'] = now();
                        $itemContrato['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                        $itemContrato['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();
                        
                        @self::insereItemContrato($itemContrato);
                        
                        $adicContArray = self::getAdicContrato($nrorg,$nrseqcontrato,$nritemOld);
                        foreach($adicContArray as $adicional){
                           
                              $adicional['NRITEMOCONTRATO'] = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'FCT_ITEMCONTRATO',1,10);
                              $adicional['NRITEMCONTRATOPAI'] = $nritemcontrato;
                              $adicional['NRSEQCONTRATO'] = $nrNovoContrato;

                              $adicional['DTINCLUSAO'] = now();
                              $adicional['DTULTATU'] = now();
                              $adicional['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                              $adicional['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();
                              @self::insereItemContrato($adicional);

                        }
                        
                        $itemFaturamentoArray = self::getItemFaturamento($nrorg,$nrseqcontrato, $nritemOld);
                        foreach($itemFaturamentoArray as $itemFaturamento){
                              $itemFaturamento['NRSEQFATUITCONT'] = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'NRSEQFATUITCONT',1,10,true);
                              $itemFaturamento['NRITEMOCONTRATO'] = $nritemcontrato;
                              $itemFaturamento['NRSEQCONTRATO'] = $nrNovoContrato;
                              $itemFaturamento['DTINCLUSAO'] = now();
                              $itemFaturamento['DTULTATU'] = now();
                              $itemFaturamento['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                              $itemFaturamento['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();
                              @self::insereItemFaturamento($itemFaturamento);


                        }

                        

                  }


                  unset($itensContArray);
                  
                  $adicContArray = self::getAdicContrato($nrorg,$nrseqcontrato);
                  foreach($adicContArray as $adicional){
                        $nradicold = $adicional['NRITEMOCONTRATO'];
                        $nradicional = \Geral\Util\NovoCodigo::geraCodigo($nrorg, 'FCT_ITEMCONTRATO',1,10);
                        $adicional['NRITEMOCONTRATO'] = $nradicional;
                        $adicional['NRSEQCONTRATO'] = $nrNovoContrato;
                        $adicional['DTINCLUSAO'] = now();
                        $adicional['DTULTATU'] = now();
                        $adicional['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                        $adicional['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();

                        @self::insereItemContrato($adicional);    
                        if($adicional['IDADICCOBRCONT'] == 'N'){
                              $itemFaturamentoArray = self::getItemFaturamento($nrorg,$nrseqcontrato, $nradicold);
                              foreach($itemFaturamentoArray as $itemFaturamento){
                                    $itemFaturamento['NRSEQFATUITCONT'] = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'NRSEQFATUITCONT',1,10,true);
                                    $itemFaturamento['NRITEMOCONTRATO'] = $nradicional;
                                    $itemFaturamento['NRSEQCONTRATO'] = $nrNovoContrato;
                                    $itemFaturamento['DTINCLUSAO'] = now();
                                    $itemFaturamento['DTULTATU'] = now();
                                    $itemFaturamento['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                                    $itemFaturamento['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();
                                    @self::insereItemFaturamento($itemFaturamento);


                              }      
                        }


                  }

                  unset($adicContArray);
                  $indiceArray = self::getIndiceReajuste($nrorg, $nrseqcontrato);
                  foreach($indiceArray as $indice){
                        $indice['NRSEQCONTRATO'] = $nrNovoContrato;
                        $indice['NRSEQINDCONTR'] = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'NRSEQINDCONTR',1,10);
                        $indice['DTINCLUSAO'] = now();
                        $indice['DTULTATU'] = now();
                        $indice['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                        $indice['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();

                        @self::insereIndiceReajuste($indice);
                  }
                  unset($indiceArray);

                  $documentoArray = self::getDocumentoCont($nrorg, $nrseqcontrato);
                  foreach($documentoArray as $documento){
                        $documento['NRSEQCONTRATO'] = $nrNovoContrato; 
                        $documento['NRSEQCONTDOC'] = \Geral\Util\NovoCodigo::geraCodigo($nrorg,'NRSEQCONTDOC',1,10);

                        $documento['DTINCLUSAO'] = now();
                        $documento['DTULTATU'] = now();
                        $documento['CDOPERINCLUSAO'] = \Geral\Util\Ambiente::getCdoperador();
                        $documento['CDOPERULTATU'] = \Geral\Util\Ambiente::getCdoperador();

                        $modelodoc = \Geral\Entities\FctModelodoc::getObjectByWhere('NRSEQMODDOCFCT = :NRSEQMODDOCFCT AND NRORG = :NRORG', array(":NRSEQMODDOCFCT"      => $documento['NRSEQMODDOCFCT'],
                                          ":NRORG" => $nrrog));

                        $Txmodelodocorca = $modelodoc->getTxmodelodocorca();
                        $Txmodelodocorca = preg_replace('#<script(.*?)>(.*?)</script>#is', '', $Txmodelodocorca);
                        $documento['TXMODELODOCORCA'] = $Txmodelodocorca; 
                        @self::insereDocumentoCont($documento);
                  }
                  unset($documentoArray);



                  

                  $connection->commit();
                  tk_reload_data_with_filter();
            }catch(\Exception $e){
                  $connection->rollBack();
                  tk_warning($e->getMessage());
            }

      } 
    
     
//RETORNA UM ARRAY COM TODOS OS CAMPOS DA TABELA DE CONTRATO
      public static function getContrato($nrorg, $nrseqcontrato){
            $sql = 'SELECT * FROM FCT_CONTRATO
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO';

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato);
            
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      public static function insereContrato(array $params){
            $sql = InnerContrato::getSqlInsert();
           
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }


  //RETORNA UM ARRAY COM TODOS OS CAMPOS DA TABELA DE ITEM DE ORCAMENTO
      public static function getItensContrato($nrorg, $nrseqcontrato){
       
            $sql = "SELECT * FROM FCT_ITEMCONTRATO
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO
                       AND IDADICITEMCONT = 'N'
                     ORDER BY IDADICITEMCONT";

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato,
                            );
            
             return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      public static function getAdicContrato($nrorg, $nrseqcontrato, $nritemcontrato = null){
            $andWhere = null;
            if(!empty($nritemcontrato)){
                  $andWhere = "AND NRITEMCONTRATOPAI = :NRITEMCONTRATOPAI";
            }else{
                  $andWhere = "AND NRITEMCONTRATOPAI IS NULL";
            }
              
            $sql = "SELECT * FROM FCT_ITEMCONTRATO
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO
                       AND IDADICITEMCONT = 'S'
                       $andWhere
                     ORDER BY IDADICITEMCONT";

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato,
                            'NRITEMCONTRATOPAI'=>$nritemcontrato);
            
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }


      public static function insereItemContrato(array $params){
            $sql = InnerItemContrato::getSqlInsert();
           
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }



      public static function getFaturamentoCont($nrorg, $nrseqcontrato){
       
            $sql = "SELECT * FROM FCT_PARAMFATCONT
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO";

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato
                            );
            
             return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      
      public static function insereFaturamentoCont(array $params){
            $sql = InnerFaturamentoCont::getSqlInsert();
           
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

       public static function getItemFaturamento($nrorg, $nrseqcontrato, $nrseqitem){
       
            $sql = "SELECT * FROM FCT_PARAMFATITCONT
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO
                       AND NRITEMOCONTRATO = :NRITEMOCONTRATO
                     ";

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato,
                            'NRITEMOCONTRATO'=>$nrseqitem
                            );
            
             return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }



      public static function insereItemFaturamento(array $params){
            $sql = InnerItemFaturamento::getSqlInsert();
           
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }



      public static function getIndiceReajuste($nrorg, $nrseqcontrato){
            $sql = 'SELECT * FROM FCT_INDICECONTR
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO';

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato);
            
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      public static function insereIndiceReajuste(array $params){
            $sql = InnerIndiceReajuste::getSqlInsert();
       
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      public static function getDocumentoCont($nrorg, $nrseqcontrato){
            $sql = 'SELECT * FROM FCT_CONTRATODOC
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATO = :NRSEQCONTRATO';

            $params = array('NRORG'=>$nrorg,
                            'NRSEQCONTRATO'=>$nrseqcontrato);
            
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      public static function insereDocumentoCont(array $params){
            $sql = InnerDocumentoCont::getSqlInsert();
           
            return  \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
      }

      public static function getMaxVersaoContr($nrorg, $nrseqcontrato){
            $sql = "SELECT MAX(NRVERSAOCONTRATO) AS NRVERSAOCONTRATO
                      FROM FCT_CONTRATO
                     WHERE NRORG = :NRORG
                       AND NRSEQCONTRATOPAI = :NRSEQCONTRATO";
                  
            $params = array("NRORG"=>$nrorg,
                        "NRSEQCONTRATO"=>$nrseqcontrato);

            $resultado =   \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
          
            $valor = $resultado[0]['NRVERSAOCONTRATO'];
            if(empty($valor)){
                  $valor = 2;
            }else{
                  $valor = $valor+1;
            }
            return $valor;
      }

}

class InnerContrato extends \Windows\ZdFct00004000\TabZdFct00004000\Custom{
      public static function getSqlInsert(){
            return static::$INSERT;
      }
}

class InnerItemContrato extends \Windows\ZdFct00004000\TabZdFct0000400001\Custom{
      public static function getSqlInsert(){
            return static::$INSERT;
      }
}
class InnerIndiceReajuste extends \Windows\ZdFct00004000\TabZdTiporeajuste\Custom{
      public static function getSqlInsert(){
           return static::$INSERT;
      }
}

class InnerDocumentoCont extends \Windows\ZdFct00004000\TabZdFct0000400004\Mapper{
      public static function getSqlInsert(){
            return static::$INSERT;
      }
}

class InnerItemFaturamento extends \Windows\ZdFct00004000\TabZdFct0000400007\Mapper{
      public static function getSqlInsert(){
            return static::$INSERT;
      }
}


class InnerFaturamentoCont extends \Windows\ZdFct00004000\TabZdFct0000400006\Custom{
      public static function getSqlInsert(){
            return static::$INSERT;
      }
}